var Method=(function(){
	return{
		/*
		* 随机颜色，不包括透明度，无需传参
		* */
		randomColors:function() {
			var str="#";
			for(var i=0;i<3;i++){
				var r=parseInt(Math.random()*256);
				if(r<16){
					str+="0"+r.toString(16);
					continue;
				}
				str+=r.toString(16);
			}
			return str;
    	},
        /*
        * 随机颜色，参数为透明度
        * */
        randomColor:function(alpha) {
			var color="rgba(";
			for(var i=0;i<3;i++){
				color+=Math.floor(Math.random()*256)+",";
			}
			if(!isNaN(alpha) && (alpha || alpha===0)){
				if(alpha>1) alpha=1;
				return color+alpha+")";
			}
			return color+Number(Math.random().toFixed(1))+")";
    	},
		/*
		* 随机获取最小数和最大数之间的数字，不包括最大数
		* 		参数为min,max	Number类型
		* */
        randomMinToMax:function(min,max) {
       	 	return Math.floor(Math.random()*(max-min)+min);
    	},
		/*
		* 两点之间的距离
		* 		参数为point1{x:数值，y:数值}，point2{x:数值，y:数值}
		* */
        getDistance:function(point1,point2) {
       		 return Math.sqrt(Math.pow(point2.x-point1.x,2)+Math.pow(point2.y-point1.y,2));
    	},
/*
	     *
	     * 通过传入对象，将对象的内容转换为字符串?属性=属性值&属性=属性值，并且返回(函数的作用)
		* 参数
		*     1、 obj    Object  这个参数必须是一个普通参数，不能有嵌套  例：{a:1,b:2}
		* 功能：
		* 1、创建一个具有？起头的字符串
		* 2、根据初次遍历对象所有属性，来累加一个变量，从这确定该对象下有多少个属性
		* 3、设置变量i初始为0
		* 4、循环遍历该对象，不断增加i的值，如果i的值小于该对象下属性总和时，我们给尾部添加&字符串，否则不添加
		* 5、添加的内容是属性=属性值这样的字符串拼装；拼装后累加在str变量中
		* 6、输出这个str字符串
		*
		* 返回
		*     str    String   字符串   是拼装以后的对象所有属性和值    ?a=1&b=2
		*
		*     版本：
		*      1.1   修改了。。。。
		*      1.2  修改了。。。
		*      2.0  增加。。。。
		* */
        getObjectToString:function(obj) {   //声明函数
        var str="?";        //定义字符变量
        var n=0;        //定义数值对象，用于统计obj对象的属性个数
        for(var s in obj){      //for in 遍历obj
            n++;        //n循环增加，用于存放obj对象的个数
        }
        var i=0;        //定义一变量，用于判定是否为最后一属性
        for(var prop in obj){   //for  in  obj
            i++;        //i循环增加
            if(i<n){    //若属性为不是最后一个累加以下字符；
                str+=prop+"="+obj[prop]+"&";
            }else{//若属性为最后一个累加以下内容
                str+=prop+"="+obj[prop];
            }
        }
        return str;     //返回字符变量str
    },
        /*
* getRepeatIndex的作用：
*         从数组中遍历指定的数值，并将遍历到的位置放至一数组中返回
* 参数：
*       (Array,number)第一个参数为数组类型，第二个参数为传入的数值
* 功能：
*       1、声明数组变量，用于存放新生成的数组内容；
*       2、定义索引值为-1；
*       3、进入死循环后，对search从第0位开始索引；
*       4、若索引的到，将下标push至indexArr数组；若已经索引不到，将返回indexArr的值。
* 返回值：
*       Array   数组
*
* */
        getRepeatIndex:function(arr,search) {   //声明函数
			var indexArr=[];        //定义一个新的空数组
			var index=-1;       //定义索引变量
			while (true){       //进入死循环
				index=arr.indexOf(search,index+1);  //将从0下标开始索引search的值，并将下标返回至index变量
				if(index===-1){     //若上句index已不能检索到search，返回indexArr
					return indexArr;
				}
				indexArr.push(index);   //将检索到的位置放在indexArr后
			}
		},
        getRepeatIndexs:function(arr,search) {
			for(var indexArr=[],index=-1;;indexArr.push(index)){    //利用for循环进入死循环
				index=arr.indexOf(search,index+1);      //从第0项开始检索search值，并将检索到的下标赋至index中
				if(index===-1){     //若已检索不到search值
					return indexArr;    //返回indexArr
				}
			}
   	 	},
/*
		 * 获取地址栏中的时间戳&time=数值，获得的是等号后面的数值
		 * 		参数为地址栏中的url		即location.search
		 * */
        getURLObject:function (url) {
            if(!~url.indexOf("?")) return;
            url=url.split("?")[1];
            var obj={};
            var arr;
            var arr1;
            var bool=false;
            if(!~url.indexOf("&")){
                if(!~url.indexOf("=")) return;
                arr=url.split("=");
                obj[arr[0]]=isNaN(Number(arr[1])) ? arr[1] : Number(arr[1]);
                return obj;
            }
            arr=url.split("&");
            for(var i=0;i<arr.length;i++){
                if(!~arr[i].indexOf("=")) continue;
                arr1=arr[i].split("=");
                if(arr1[0].length===0) continue;
                obj[arr1[0]]=isNaN(Number(arr1[1])) ? arr1[1] : Number(arr1[1]);
                bool=true;
            }
            if(bool) return obj;
        },
        /*
		* createElem的作用：
		*          在js中创建一个元素
		* 参数：
		*          type(元素类型），parent（父级元素），content（元素中的内容），style（元素样式），
		*          eventType(元素事件类型），eventCallBack(事件回调函数)
		* createElem的功能：
		*          1、创建一个元素；
		*          2、若父级元素岑在，将创建的元素插入为父级元素的子标签；
		*          3、若内容存在，判断内容的类型，根据不同的类型处理不同的属性值或文本节点；
		*          4、若元素样式存在，调用setStyle()函数；
		*          5、若eventType和eventCallBack存在，给元素添加事件监听函数；
		*          6、返回创建的新元素。
		* 返回值：
		*          elem    一个元素名称
		* */
        createElem:function(type,parent,content,style,eventType,eventCallBack){
        	var elem=document.createElement(type);
        	if(parent){
        		parent.appendChild(elem);
			} 
			if (content){
        		if (type ==="input"){
        			elem.value = content;
				} else if (type==="img"){
        			elem.src = content;
				} else{
        			var text=document.createTextNode(content);
        			elem.appendChild(text);
				}
			} 
			if (style){
        		Method.setStyle(elem,style);
			}
			if (eventType&&eventCallBack){
        		elem.addEventListener(eventType, eventCallBack);
			}
			return elem;
		},
		setStyle:function(elem,style){
			for (var str in style){
				elem.style[str]=style[str];
			}
		},
		/*
		 *setCookie:
		 * 		设置cookie
		 * 参数：	
		 * 		（name,value,day）	cookie属性名，cookie属性值，Number类型--过期天数
		 * 无返回值
		 * */
		setCookie:function(name,value,day){
			var oDate=new Date();
			oDate.setDate(oDate.getDate()+day);
			document.cookie=name+"="+value+";expires="+oDate;
		},
		/*
		 *getCookie:
		 * 		通过cookie名获取到cookie的值
		 * 参数：
		 * 		name 	coolie名
		 * 返回值：
		 * 		cookie值
		 * 
		 * */
		getCookie:function(name){
			var str=document.cookie;
			var arr=str.split("; ");
			for(var i=0;i<arr.length;i++){
				var arr1=arr[i].split("=");
				if(arr1[0]==name){
					return arr1[1];
				}
			}
		},
		/*
		 *removeCookie:
		 * 		移除cookie
		 * 参数：
		 * 		name	cookie名
		 *无返回值
		 * 
		 * */
		removeCookie:function(name){
			this.setCookie(name,1,-1);
		},
		
		
		
		
		
		/*
		 *	getElemId的作用：
		 *			获得传入元素及其子元素的ID
		 *	参数：
		 *			null
		 *	功能：
		 *			1.定义一个空对象；
		 *			2.返回一个用于递归的函数，参数为元素类型；
		 *			3.如果元素存在ID，让元素的ID为dic的属性，元素类型为dic的属性值；
		 *			4.遍历传入元素的子元素，并将子元素进行递归；
		 *			5.返回一个对象。
		 *	返回：
		 *			dic 	Object类型
		 *	使用示例：
		 *			var test=Method.getElemId();
         *  		var rec=test(document.body);
         *   		console.log(rec);
		 * 
		 * */
		getElemId:function(){
			var dic={};
			return function recur(elem){
				if(elem.id){
					dic[elem.id]=elem;
				}
				for(var i=0;i<elem.children.length;i++){
                    recur(elem.children[i]);
				}
				return dic;
			}
		},
		/*
		*	objectClone的作用：
		*		对原对象进行深复制
		*	参数：
		*		targetObj,sourceObj		目标对象，源对象
		*	功能：
		*		1.获取源对象的属性名；
		*		2.对源对象的属性名进行遍历，遍历中获得每个对象的属性描述；
		*		3.定义一个空对象；
		*		4.如果源对象的value描述为object并且不为空，定义目标对象的属性，属性为name[i],描述内容为是否可替换，可删除；是否可写入；是否可枚举；value为空对象obj；
		*		5.将空对象obj,desc.value作为参数进行递归；
		*		6.否则的话直接定义目标对象的属性。
		*
		* */
		objectClone:function(targetObj,sourceObj){
			var names=Object.getOwnPropertyNames(sourceObj);
			for(var i=0;i<names.length;i++){
				var desc=Object.getOwnPropertyDescriptor(sourceObj,names[i]);
				if(typeof (desc.value)==="object"&&desc.value!==null){
                    var obj={};
					Object.defineProperty(targetObj,name[i],{
						configurable:desc.configurable,
						writable:desc.writable,
						enumerable:desc.enumerable,
						value:obj,
					});
					objectClone(obj,desc.value);
				}else{
					Object.defineProperty(targetObj,name[i],desc);
				}
			}
			return targetObj;
		},
	}
})();
